package Tetris;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.JPanel;
import javax.swing.Timer;

//Ewen Kerbs,Zhe Wang-Holkenbrink
public class Board extends JPanel implements KeyListener
{
  private  static int FPS =60;
  private  static int delay =FPS/1000;

  public static final int BOARD_WIDTH=11;
  public static final int BOARD_HEIGHT=20;
  public static final int BLOCK_SIZE=30;

  private Timer loop;
  private Color[][] board = new Color[BOARD_HEIGHT][BOARD_WIDTH];
  private Stein [] steine=new Stein[7];
  private Stein currenStein;

private Color[] colors ={Color.decode("#ff00bf"),Color.decode("#0000ff"),Color.decode("#00ff80"),Color.decode("#ff8000"),Color.decode("#ffb3b3"),
        Color.decode("#8000ff"),Color.decode("#ff0040"),};



  public Board() {

    steine[0]= new Stein(new int[][]{
      {1,1,1,1}
    }, this,colors[0]);
    steine[1]= new Stein(new int[][]{
            {1,1,1},
            {0,1,0}
    }, this,colors[1]);
    steine[2]= new Stein(new int[][]{
            {1,1,1},
            {1,0,0}
    }, this,colors[2]);
    steine[3]= new Stein(new int[][]{
            {1,1,1},
            {0,0,1}
    }, this,colors[3]);
    steine[4]= new Stein(new int[][]{
            {1,1,1},
            {1,1,0}
    }, this,colors[4]);
    steine[5]= new Stein(new int[][]{
            {1,1,0},
            {0,1,1}
    }, this,colors[5]);
    steine[6]= new Stein(new int[][]{
            {1,1},
            {1,1}
    }, this,colors[6]);

    currenStein= steine[0];

    loop = new Timer(delay, new ActionListener() {
      int n = 0;

      @Override
      public void actionPerformed(ActionEvent e) {
        update();

        repaint();
        //System.out.println(n++);
      }
    });
    loop.start();
  }

  private void update(){
    currenStein.update();
  }


  public void setCurrenStein() {
    currenStein = steine[1];
    currenStein.reset();
  }

  public Color[][] getBoard(){
    return board;
  }

  @Override
  protected void paintComponent(Graphics g) {
    super.paintComponent(g);
    g.fillRect(0, 0, getWidth(), getHeight());
    g.setColor(Color.lightGray);

    currenStein.render(g);

    for(int row=0;row< board.length;row++){
      for(int col = 0;col< board[row].length;col++){
        if(board[row][col] !=null){
          g.setColor(board[row][col]);
          //
          g.fillRect(col*BLOCK_SIZE,row*BLOCK_SIZE,BLOCK_SIZE,BLOCK_SIZE);
        }
      }
    }

    //shape mit 2-Forschleife


    for (int row = 0; row < BOARD_HEIGHT+1; row++) {
      g.drawLine(0, BLOCK_SIZE * row, BLOCK_SIZE * BOARD_WIDTH, BLOCK_SIZE * row);
    }
    for (int col = 0; col < BOARD_WIDTH+1; col++) {
      g.drawLine(col * BLOCK_SIZE, 0, col * BLOCK_SIZE, BLOCK_SIZE * BOARD_HEIGHT);
    }

  }

  @Override
  public void keyTyped(KeyEvent e) {

  }

  @Override
  public void keyPressed(KeyEvent e) {
    if(e.getKeyChar() == KeyEvent.VK_SPACE){
      currenStein.speedup();
    }else if(e.getKeyChar() == KeyEvent.VK_ENTER){
      currenStein.moveRigth();
    }
    else if(e.getKeyChar() == KeyEvent.VK_ESCAPE){
      currenStein.moveLeft();
      }
    }

  @Override
  public void keyReleased(KeyEvent e) {
    if(e.getKeyChar() == KeyEvent.VK_SPACE){
      currenStein.speedDown();
    }
  }
}
