package Tetris;

import java.awt.*;

public class Stein {
    private int x=4,y=0;
    private int normal =850;
    private int fast = 50;
    private long beginTime;
    private int delayTime = normal;
    private int deltax = 0;
    private boolean collision = false;

    public static final int BOARD_WIDTH=11;
    public static final int BOARD_HEIGHT=20;
    public static final int BLOCK_SIZE=30;

    private int[][]coords;
    private Board board;
    private Color color;

    public Stein(int [][] coords, Board board, Color color){
        this.coords = coords;
        this.board = board;
        this.color=color;
    }
    public void setX(int x){
        this.x=x;
    }

    public void setY(int y){
        this.y=y;
    }

    public void reset(){
        this.x=4;
        this.y=0;
        collision= false;

    }
    public void update(){
        if(collision){
            for(int row =0;row < coords.length;row++){
                for(int col =0;col < coords[0].length;col++){
                    if (coords[row][col]!=0){
                        board.getBoard()[y+row][x+col]= color;
                    }
                }
            }
            board.setCurrenStein();
            return;
        }
        if(!(x + deltax + coords[0].length >11) && !(x + deltax<0))
        {
            x +=deltax;
        }

        deltax= 0;
        if(System.currentTimeMillis() -beginTime > delayTime){
            if(!(y+1+coords.length > BOARD_HEIGHT)){
                y++;
            }else{
                collision=true;
            }

            beginTime=System.currentTimeMillis();
        }
    }
public void render(Graphics g){
    for(int row=0;row< coords.length;row++){
        for(int col = 0;col< coords[0].length;col++){
            if(coords[row][col] !=0){
                g.setColor(Color.yellow);
                //
                g.fillRect(col*BLOCK_SIZE+x*BLOCK_SIZE,row*BLOCK_SIZE+y*BLOCK_SIZE,BLOCK_SIZE,BLOCK_SIZE);
            }
        }
    }
}

public void speedup(){
    delayTime=fast;
}
public void speedDown(){
    delayTime=normal;
}
public void moveRigth(){
    deltax = 2;
    }
    public void moveLeft(){
        deltax = -2;
    }
}
